RUNS_HUMAN_VERSION	equ	3
	.include doscall.mac
	.even
	.text
_PicBitLoad1	macro
	local	bit1exist,bit1_bufexist

	dbra	d7,bit1exist
	dbra	d6,bit1_bufexist
	bsr	_PicBufferNext
bit1_bufexist:
	moveq.l	#15,d7
	move.w	(a5)+,d5
bit1exist:
	moveq.l	#0,d0
	add.w	d5,d5
	scs	d0
	neg.b	d0

	endm

_PicBitLoad2	macro
	local	bl2_lp,bl2_bitexist,bl2_bitoff,bl2_bufexist

	moveq.l	#0,d1
	move.w	d5,d1
bl2_lp:
	dbra	d7,bl2_bitexist
	dbra	d6,bl2_bufexist
	bsr	_PicBufferNext
bl2_bufexist:
	moveq.l	#15,d7
	move.w	(a5)+,d1
bl2_bitexist:
	add.l	d1,d1
	dbra	d2,bl2_lp
	move.w	d1,d5
	clr.w	d1
	swap.w	d1
	move.l	d1,d0

	endm


	.even
	.globl _loadPifile
_loadPifile:
	movem.l d3/d4/d5/d6/d7/a3/a4/a5/a6,-(sp)
	move.l	40(sp),a6	*_psi
	move.l	sp,1000(a6)
	move.l	#73744,-(sp)
	DOS	_MALLOC
	move.l	d0,4(a6)	*filebuf
	addq.w	#4,sp
	bge	?53
	move.l	a6,-(sp)
	jbsr	_EndOfDraw
	addq.w	#4,sp
	move.l	#205,d0
	bra	?1
?53
	move.l	#8192,8(a6)
	moveq.l	#0,d7
	moveq.l	#0,d6
	moveq.l	#0,d5
	move.l	d7,58(a6)
	move.l	d7,62(a6)
	lea.l	_Picgetc,a3
	jbsr	(a3)
	cmp.b	#'P',d0
	bne	eformat
	jbsr	(a3)
	cmp.b	#'i',d0
	bne	eformat
	move.l	#16384,d1
	move.l	44(sp),a0
	moveq.l	#0,d3
comlp1:
	jbsr	(a3)
	cmp.b	#$1a,d0
	beq	comlp1break
	move.b	d0,(a0)+
	addq.l	#1,d3
	cmp.l	d1,d3
	blt	comlp1
comlp1break:
	cmp.l	d1,d3
	beq	eformat
	moveq.l	#0,d3
	move.b	d3,(a0)
comlp2:
	jbsr	(a3)
	tst.b	d0
	beq	comlp2break
	addq.l	#1,d3
	cmp.l	d1,d3
	blt	comlp2
comlp2break:
	cmp.l	d1,d3
	beq	eformat
	jbsr	(a3)
	lea.l	586(a6),a0
	move.l	d0,(a0)+
	and.w	#65407,d0
	bne	eformat
	jbsr	(a3)
	move.l	d0,(a0)+
	jbsr	(a3)
	move.l	d0,(a0)
	tst.l	-(a0)
	beq	?19
	tst.l	d0
	bne	?18
?19:
	moveq.l	#1,d0
	move.l	d0,(a0)+
	move.l	d0,(a0)
?18:
	jbsr	(a3)
	move.l	d0,598(a6)
	moveq.l	#4,d1
	cmp.l	d0,d1
	beq	fourbit
	moveq.l	#8,d1
	cmp.l	d0,d1
	beq	eightbit
eformat:
	move.l	a6,-(sp)
	jbsr	_EndOfDraw
	addq.w	#4,sp
	moveq.l	#101,d0
	add.w	d0,d0
	bra	?1
eightbit:
	move.l	#256,606(a6)	*realwidth
	move.l	4(a6),a0
	lea.l	8192(a0),a0
	move.l	a0,54(a6)
	move.l	#_PiReadColor256,602(a6)
	moveq.l	#1,d0
	bra	?55
fourbit:
	moveq.l	#16,d0
	move.l	d0,606(a6)	*realwidth
	moveq.l	#0,d0
	move.l	d0,54(a6)
	move.l	#_PiReadColor16,602(a6)
?55:
	move.l	d0,1004(a6)	*_curgmode
	jbsr	(a3)
	jbsr	(a3)
	jbsr	(a3)
	jbsr	(a3)
	jbsr	(a3)
	move.l	d0,d3
	jbsr	(a3)
	lsl.w	#8,d3
	move.b	d0,d3
	tst.l	d3
	bra	?23
?26:
	jbsr	(a3)
	subq.l	#1,d3
?23:
	bgt	?26
	jbsr	(a3)
	move.l	d0,d3
	jbsr	(a3)
	lsl.w	#8,d3
	move.b	d0,d3
	lea	20(a6),a4
	move.l	d3,(a4)+	*width
	jbsr	(a3)
	move.l d0,d3
	jbsr (a3)
	move.l d0,a0
	asl.l #8,d3
	lea (a0,d3.l),a0
	move.l a0,(a4)		*height
*	move.l -(a4),a4		*width
*	pea 2(a0)
*	pea (a4)
*	jbsr ___mulsi3
*	addq.w #8,sp
*	move.l d0,a0
*	pea 64(a0)
*	DOS _MALLOC
*	move.l d0,38(a6)	*chainbuf
*	addq.w #4,sp
*	jbge ?27
*?27:
	lea 66(a6),a0
	tst.b 589(a6)
	jbge rgbloadset
	moveq.l #4,d0
	cmp.l 598(a6),d0
	jbne set256
	swap.w d5
	swap.w d6
	moveq.l #0,d3
?42:
	btst	#1,d3
	beq	?33
	moveq.l	#1,d1
	bra	?34
?33:
	moveq.l	#0,d1
?34:
	moveq.l	#1,d0
	moveq.l	#7,d2
	cmp.l	d3,d2
	bge	?35
	moveq.l	#2,d0
?35:
	mulu	d1,d0
	asl.l	#4,d0
	move.w	d0,d6
	subq.w	#1,d6
	btst	#2,d3
	beq	?36
	moveq.l	#1,d1
	bra	?37
?36:
	moveq.l #0,d1
?37:
	moveq.l #1,d0
	moveq.l #7,d2
	cmp.l d3,d2
	jbge ?38
	moveq.l #2,d0
?38:
	mulu	d1,d0
	asl.l #4,d0
	move.w d0,d5
	subq.w #1,d5
	btst #0,d3
	jbeq ?39
	moveq.l #1,d1
	jbra ?40
?39:
	moveq.l #0,d1
?40:
	moveq.l #1,d0
	moveq.l #7,d2
	cmp.l d3,d2
	jbge ?41
	moveq.l #2,d0
?41:
	mulu	d1,d0
	asl.l #4,d0
	move.w d0,d4
	subq.w #1,d4
	move.l d3,d1
	add.l d1,d1
	move.w d6,d0
	asl.w #6,d0
	move.w d5,d2
	asl.w #5,d2
	asl.w #6,d2
	or.w d2,d0
	move.w d4,d2
	add.w d2,d2
	or.w d2,d0
	move.w d0,(a0,d1.l)
	addq.l #1,d3
	moveq.l #15,d0
	cmp.l d3,d0
	jbge ?42
	swap.w d5
	swap.w d6
	jbra ?48
set256:
	moveq.l #0,d3
?47:
	move.l d3,d0
	asr.l #2,d0
	and.w #7,d0
	move.l d3,d2
	asr.l #5,d2
	move.w d3,d1
	and.w #3,d1
	asl.w #8,d0
	asl.w #8,d2
	asl.w #5,d2
	or.w d2,d0
	asl.w #4,d1
	or.w d1,d0
	move.w d0,(a0)+
	addq.l #1,d3
	cmp.l #255,d3
	jble ?47
	jbra ?48
rgbloadset:
	move.l 606(a6),d3
	subq.w #1,d3
?52:
	jbsr (a3)	*R
	move.b d0,d1
	jbsr (a3)	*G
	lsl.w #5,d0
	move.b d1,d0
	and.b #$f8,d0
	add.w d0,d0
	add.w d0,d0
	move.w d0,d1
	jbsr (a3)	*B
	lsr.b #3,d0
	or.b d0,d1
	add.w d1,d1
	move.w d1,(a0)+
	dbra d3,?52
?48:
	bsr	_ColorTableInitialize
*	bsr	_ExpandPi

*	lea.l	_ng,a0
*	move.l	20(a6),(a0)+	*h
*	move.l	24(a6),(a0)+	*v
*	move.l	1004(a6),d0	*_curgmode
*	addq.w	#1,d0
*	add.w	d0,d0
*	add.w	d0,d0
*	move.l	d0,(a0)+	*color
*	move.l	38(a6),(a0)+	*buf
*	moveq.l	#66,d0
*	add.l	a6,d0
*	move.l	d0,(a0)		*palet

*	move.l #_drawPi,_drawfunc
	moveq.l #100,d0
	add.w d0,d0
?1:
	swap.w d6
	move.w d5,d6
	move.l d6,58(a6)
	move.w d7,64(a6)
	move.l a5,12(a6)
	movem.l (sp)+,d3/d4/d5/d6/d7/a3/a4/a5/a6
	rts
	.even
	.globl _ColorTableInitialize
_ColorTableInitialize:
	movem.l	d3/d4/d5,-(sp)
	lea	598(a6),a0
	moveq.l	#4,d5
	cmp.l	(a0),d5
	bne	?76
	moveq.l #0,d2
	lea.l	654(a6),a1
	move.l	a1,d4
	moveq.l #15,d5
?84:
	moveq.l	#0,d1
	move.l	d2,d0
	asl.l	#4,d0
	add.l	d2,d0
	move.l	d4,a0
	add.l	d0,a0
	move.b	d2,d3
	add.b	#16,d3
?83:
	move.b	d3,d0
	sub.b	d1,d0
	and.b	#15,d0
	move.b	d0,(a0,d1.l)
	addq.l	#1,d1
	cmp.l	d1,d5
	bge	?83
	addq.l	#1,d2
	cmp.l	d2,d5
	bge	?84
	bra	?85
?76:
	moveq.l	#0,d2
	lea.l	54(a6),a1
?93:
	moveq.l #0,d1
	move.l d2,d4
	asl.l #8,d4
	move.b d2,d3
?92:
	move.l (a1),a0
	move.l d1,d0
	add.l d4,d0
	move.b d3,d5
	sub.b d1,d5
	move.b d5,(a0,d0.l)
	addq.l #1,d1
	cmp.l #255,d1
	jble ?92
	addq.l #1,d2
	cmp.l #255,d2
	jble ?93
?85:
	movem.l (sp)+,d3/d4/d5
	rts
	.even

_ExpandPi:
	movem.l	d3/d4/a3/a4,-(sp)
	moveq.l	#0,d4
	move.w	d4,36(a6)
	lea.l	602(a6),a4
	move.l	(a4),a0
	jbsr	(a0)
	move.l	d0,d3
	move.l	(a4),a4
	jbsr	(a4)
	move.l	d0,d2
	move.l	38(a6),32(a6)	*screen3= chainbuf
	move.l	20(a6),d1
	lea.l	32(a6),a1
	move.l	(a1),a0
	move.b	d3,d0
	bra	?95
?98:
	move.b	d0,(a0)+
	addq.l	#1,(a1)
	move.b	d2,(a0)+
	addq.l	#1,(a1)
?95:
	dbra	d1,?98
	move.l	20(a6),d0
	move.l	d0,638(a6)
	move.l	d0,d4
	add.l	d4,d4
	move.l	d4,642(a6)
	move.l	d0,d4
	subq.l	#1,d4
	move.l	d4,646(a6)
	move.l	d0,d4
	addq.l	#1,d4
	move.l	d4,650(a6)
	lea	626(a6),a3
	move.l	24(a6),d1
	mulu	d1,d0
	bge	?99
	addq.l	#1,d0
?99:
	asr.l	#1,d0
	move.l	d0,(a3)
	moveq.l	#-1,d4
	move.l	d4,630(a6)
	movem.l	(sp)+,d3/d4/a3/a4
	rts
	.even
	.globl _drawPi
_drawPi:
	movem.l d3/d4/d5/d6/d7/a3/a4/a5/a6,-(sp)
	move.l	40(sp),a6	*_psi

	move.l sp,1000(a6)
	move.l 58(a6),d6
	move.w d6,d5
	swap.w d6
	move.w 64(a6),d7
	move.l 12(a6),a5
	move.l 602(a6),a3	*readcolor
	bsr	_ExpandPi
	move.l	32(a6),a4	*screen3
?102:
	moveq.l #1,d2
	_PicBitLoad2
	move.l d0,d1
	cmp.b #3,d0
	bne ?105
	_PicBitLoad1
	add.l d0,d1		*position
?105:
	lea.l	634(a6),a0
	move.l	d1,(a0)		*position
	move.l	-(a0),d0	*previous position
	cmp.l	d1,d0
	bne	?106
	moveq.l	#-1,d0
	move.l	d0,(a0)		*previous position
*	move.l	32(a6),a4	*screen3
	subq.w	#1,a4
	clr.w	d0
	move.b	(a4)+,d0
	move.l	-(a0),d4	*restsize
	move.w	d0,36(a6)	*color
getcollp:
	jbsr	(a3)
	move.b	d0,(a4)+
	jbsr	(a3)
	move.b	d0,(a4)+
?110:
	subq.l	#1,d4
	_PicBitLoad1
	bne	getcollp
*	move.l	a4,32(a6)	*screen3
	move.l	d4,626(a6)	*restsize
	bra	?102
?106:
	move.l	d1,(a0)	*previousposition= position
_PiReadLength:
	_PicBitLoad1
	bne	rl_nbit
	moveq.l	#1,d2
	bra	rl_end
rl_nbit:
	moveq.l	#1,d3
rl_lp:
	_PicBitLoad1
	beq	rl_set
	addq.w	#1,d3
	bra	rl_lp
rl_set:
	move.l	d3,d2
	bsr	_PicBitLoadn
	moveq.l	#1,d1
	asl.l	d3,d1
	add.l	d1,d0
	move.l	d0,d2	*length
rl_end:
	ble	?102
	lea.l	626(a6),a0	*restsize
	move.l	(a0),d0
	sub.l	d2,d0
	bge	?113
	add.l	d0,d2		*length
	moveq.l	#0,d0
?113:
	move.l	d0,(a0)		*restsize
	move.l	634(a6),d0	*position
	beq	?119
	moveq.l	#4,d1
	cmp.l	d0,d1
	blt	?114
	moveq.l	#1,d1
	cmp.l	d0,d1
	bgt	?114
_MoveMem:
	lea	634(a6),a2
	add.w	d0,d0
	add.w	d0,d0
*	move.l	32(a6),a0	*screen3
*	move.l	a0,a1
	move.l	a4,a1
	sub.l	(a2,d0.w),a1
	bra	mm_ent
mm_lp:
*	move.b	(a1)+,(a0)+
*	move.b	(a1)+,(a0)+
	move.b	(a1)+,(a4)+
	move.b	(a1)+,(a4)+
mm_ent:
	subq.l	#1,d2
	bpl	mm_lp
mm_end
*	move.l	a0,32(a6)
	bra	?114
?119:
	swap.w	d5
	swap.w	d6
*	move.l	32(a6),d0
*	move.l	d0,a0
*	subq.w	#4,a0
	lea.l	-4(a4),a0
	move.b	(a0)+,d6
	move.b	(a0)+,d5
	move.b	(a0)+,d4
	move.b	(a0)+,d3
*	add.l	d2,d0
*	add.l	d2,d0
*	move.l	d0,32(a6)
	adda.l	d2,a4
	adda.l	d2,a4

	cmp.b	d3,d4
	bne	?120
	move.b	d3,d5
	move.b	d4,d6
?120:
	subq.l	#1,d2
	bne	?121
	move.b	d6,(a0)+
	move.b	d5,(a0)
	swap.w	d5
	swap.w	d6
	bra	?114
?121:
	addq.l	#2,d2
	asr.l	#1,d2
	move.l	#16000,d1
?123:
	cmp.l	d1,d2
	ble	?126
	move.l	d1,d0
	bra	?127
?126:
	move.l	d2,d0
?127:
	sub.l	d0,d2
	subq.w	#1,d0
?128:
	move.b	d6,(a0)+
	move.b	d5,(a0)+
	move.b	d4,(a0)+
	move.b	d3,(a0)+
	dbra	d0,?128
	tst.l	d2
	bne	?123
	swap.w	d5
	swap.w	d6
?114:
	tst.l	626(a6)	*restsize
	bgt	?102
?103:
	move.l	a6,-(sp)
	jbsr	_EndOfDraw
	addq.w	#4,sp
	move.l	#201,d0
	movem.l	(sp)+,d3/d4/d5/d6/d7/a3/a4/a5/a6
	rts
	.even

_PiReadColor16:
	_PicBitLoad1
	beq	?148
	_PicBitLoad1
	moveq.l	#0,d2
	bra	?149
?148:
	_PicBitLoad1
	bne	?150
	_PicBitLoad1
	moveq.l	#2,d2
	bra	?149
?150:
	_PicBitLoad1
	bne	?151
	moveq.l #1,d2
	_PicBitLoad2
	moveq.l	#4,d2
	bra	?149
?151:
	moveq.l	#2,d2
	_PicBitLoad2
	moveq.l	#8,d2
?149:
	add.l	d0,d2
	moveq.l	#0,d1
	move.w	36(a6),d1	*psi.color
	move.l	d1,d0
	lsl.w	#4,d0
	add.w	d1,d0
	lea.l	654(a6),a2	*colortable
	adda.l	d0,a2		*p
	lea	(a2,d2.l),a0	*p[color]
	moveq.l	#0,d0
	move.b	(a0),d0		*k
	tst.l	d2		*color
	beq	?152
	lea	1(a0),a1
	bra	?153
?155:
	move.b	-(a0),-(a1)
?153:
	dbra	d2,?155
	move.b	d0,(a2)
?152:
	move.w	d0,36(a6)
	rts
	.even
	.globl _PiReadColor256
_PiReadColor256:
	_PicBitLoad1
	jbeq ?158
	_PicBitLoad1
	moveq.l #0,d1
	jbra ?159
?158:
	_PicBitLoad1
	jbne ?160
	_PicBitLoad1
	moveq.l #2,d1
	jbra ?159
?160:
	_PicBitLoad1
	jbne ?161
	moveq.l #1,d2
	_PicBitLoad2
	moveq.l #4,d1
	jbra ?159
?161:
	_PicBitLoad1
	jbne ?162
	moveq.l #2,d2
	_PicBitLoad2
	moveq.l #8,d1
	jbra ?159
?162:
	_PicBitLoad1
	jbne ?163
	moveq.l #3,d2
	_PicBitLoad2
	moveq.l #16,d1
	jbra ?159
?163:
	_PicBitLoad1
	jbne ?164
	moveq.l #5,d2
	jbsr _PicBitLoadn
	moveq.l #32,d1
	jbra ?159
?164:
	_PicBitLoad1
	jbne ?165
	moveq.l #6,d2
	jbsr _PicBitLoadn
	moveq.l #64,d1
	jbra ?159
?165:
	moveq.l #7,d2
	jbsr _PicBitLoadn
	moveq.l #64,d1
	add.w d1,d1
?159:
	add.l d0,d1
	moveq.l #0,d0
	move.w 36(a6),d0
	lsl.l #8,d0
	move.l 54(a6),a2	*colortable256
	add.l d0,a2
	lea (a2,d1.l),a0
	moveq.l #0,d0
	move.b (a0),d0
	tst.l d1
	beq ?166
	lea 1(a0),a1
	bra ?167
?169:
	move.b -(a0),-(a1)
?167:
	dbra d1,?169
	move.b d0,(a2)
?166:
	move.w d0,36(a6)
	rts
	.even
_Picgetc:
	subq.w #8,d7
	bpl gc_bitexist
	dbra d6,gc_bufexist
	jbsr _PicBufferNext
gc_bufexist:
	moveq.l #8,d7
	move.w (a5)+,d5
gc_bitexist
	moveq.l #0,d0
	rol.w #8,d5
	move.b d5,d0
	clr.b d5
	rts
	.even
_PicBitLoadn:
	moveq.l #0,d1
	tst.w d7
	beq bl_nextbuf
	cmp.w d7,d2
	ble allexist
bl_lp1:
	lsl.l d7,d1
	rol.w d7,d5
	or.w d5,d1
	sub.w d7,d2
bl_nextbuf
	dbra d6,bl_bufexist
	jbsr _PicBufferNext
bl_bufexist:
	moveq.l #16,d7
	move.w (a5)+,d5
	cmp.w d7,d2
	bgt bl_lp1
allexist:
	sub.w d2,d7
	subq.w #1,d2
bl_lp2:
	add.l d1,d1
	add.w d5,d5
	bcc bl_lp2ent
	addq.w #1,d1
bl_lp2ent:
	dbra d2,bl_lp2
	move.l d1,d0
	rts
	.even
_PicBufferNext:
	move.l 4(a6),a5
	move.l 8(a6),-(sp)
	pea (a5)
	move.w 2(a6),-(sp)
	DOS _READ
	move.w d0,d6
	lea 10(sp),sp
	bgt pbn_dataexist
	move.l	a6,-(sp)
	jbsr _EndOfDraw
	addq.w	#4,sp
	move.l 1000(a6),sp
	movem.l (sp)+,d3-d7/a3-a6
	rts
pbn_dataexist:
	subq.w #1,d6
	lsr.w #1,d6
	rts
	.even
	.end
