*	PIXL.X	original mu./ADV
*	pixl.r	version 1.00 +2 by rick 1998
*	 	modified for gview.win	1998

	.include	doscall.mac
	.text

	.globl	_loadPIXfile
	.globl	_loadPAT4file
	.globl	_drawPIX

BITSET	macro
	local	noput

	add.w	d4,d4
	bcc	noput
	or.b	d6,(a2)
noput:
	addq.w	#1,a2

	endm


firstread:
	move.l	#16384,d0
	move.l	d0,8(a6)	*filebufsize
	move.l	d0,-(sp)
	DOS	_MALLOC
	addq.w	#4,sp
	tst.l	d0
	bmi	memerr
	move.l	d0,4(a6)	*filebuf
readheader:
	moveq.l	#8,d1		*header 8 byte
	move.l	d1,-(sp)
	move.l	d0,-(sp)	*filebuf
	move.w	2(a6),-(sp)	*filehandle
	DOS	_READ
	lea.l	10(sp),sp
	tst.l	d0
	bmi	eread
	rts

_loadPIXfile:
	movem.l	d4-d7/a6,-(sp)
	movea.l	24(sp),a6
	bsr	firstread
	movea.l	4(a6),a2
	cmpi.l	#$54583136,(a2)	*'TX16'
	bne	eformat
	moveq.l	#40,d1		*pix header2 40byte
	move.l	d1,-(sp)
	move.l	a2,-(sp)	*filebuf
	move.w	2(a6),-(sp)	*filehandle
	DOS	_READ
	lea.l	10(sp),sp
	tst.l	d0
	bmi	eread
	lea.l	8(a2),a0
	bra	setparam

_loadPAT4file:
	movem.l	d4-d7/a6,-(sp)
	movea.l	24(sp),a6
	bsr	firstread
	move.l	4(a6),a2
	tst.l	(a2)		*0000
	bne	eformat
	lea.l	sxpalet(pc),a0

setparam:
	lea.l	66(a6),a1
	moveq.l	#15,d0
setpalet:
	move.w	(a0)+,(a1)+
	dbra	d0,setpalet

	moveq.l	#0,d1
	moveq.l	#15,d0
	move.w	4(a2),d1	*xdots
	move.l	d1,20(a6)	*width

	move.l	d1,d5		*width
	and.w	d0,d5
	subq.l	#1,d5
	move.l	d5,32(a6)	*runlength

	add.w	d0,d1
	lsr.w	#4,d1
	subq.l	#1,d1
	move.l	d1,16(a6)	*realwidth(hword)

	moveq.l	#0,d1
	move.w	6(a2),d1	*ylines
	move.l	d1,24(a6)	*height
	moveq.l	#100,d0
	add.w	d0,d0
	movem.l	(sp)+,d4-d7/a6
	rts

_drawPIX:
	movem.l	d4-d7/a6,-(sp)
	movea.l	24(sp),a6

	move.l	a6,-(sp)
	jbsr	_iclr
	addq.w	#4,sp

	moveq.l	#0,d0
	moveq.l	#1,d6
	moveq.l	#3,d7		*planes

planeloop:
	move.l	24(a6),d2	*height
	subq.w	#1,d2
	movea.l	38(a6),a2	*chainbuf
yloop:
	move.l	16(a6),d1	*realwidth
xloop:
	dbra	d0,putline
datread:
	movea.l	4(a6),a1
	move.l	8(a6),-(sp)	*filebufsize
	move.l	a1,-(sp)	*filebuf
	move.w	2(a6),-(sp)	*filehandle
	DOS	_READ
	lea.l	10(sp),sp
	tst.l	d0
	bmi	eread

	lsr.w	#1,d0			*word loopct= read byte/2
	subq.w	#1,d0
putline:
	move.w	(a1)+,d4
	tst.w	d1
	beq	edge
wordloop:
	BITSET
	BITSET
	BITSET
	BITSET
	BITSET
	BITSET
	BITSET
	BITSET
	BITSET
	BITSET
	BITSET
	BITSET
	BITSET
	BITSET
	BITSET
	BITSET
wordlpend:
	dbra	d1,xloop
	dbra	d2,yloop
	add.w	d6,d6		*plane shift
	dbra	d7,planeloop
	move.l	#201,d3
	bra	terminate

edge:
	move.l	32(a6),d5	*runlength
	bmi	wordloop
edgelp:
	BITSET
	dbra	d5,edgelp
	bra	wordlpend

memerr:
	move.l	#205,d3	
	bra	terminate
eformat:
	moveq.l	#101,d3
	add.w	d0,d0
	bra	terminate
eread:
	move.l	#203,d3
terminate:
	move.l	a6,-(sp)
	jbsr	_EndOfDraw
	addq.w	#4,sp
	move.l	d3,d0
	movem.l	(sp)+,d4-d7/a6
	rts

	.even
	.data

sxpalet:
	.dc.w	$0000,$c5b1,$83e1,$1,$ffc1,$7c1,$f801,$3f
	.dc.w	$ff7f,$c5b1,$83e1,$1,$ffc1,$7c1,$f801,$3f

	.end
