/*
	Copyright 1995 Ogasawara Hiroyuki(COR.)

	modified 1998 by Shinichi Honma
*/

#include	<corlib.h>
#include	<sys_doslib.h>
#include	"gview.h"

typedef struct {
		char	*ext;
		GVIEW	*(*exec)();
} T_Loader;


extern GVIEW	*GV_Load_Pi();
extern GVIEW	*GV_Load_Pic();
extern GVIEW	*GV_Load_Mag();
extern GVIEW	*GV_Load_Hg();
extern GVIEW	*GV_Load_Jpeg();
extern GVIEW	*GV_Load_Glm();
extern GVIEW	*GV_Load_Gif();
extern GVIEW	*GV_Load_Ppm();
extern GVIEW	*GV_Load_Bmp();
extern GVIEW	*GV_Load_Pix();
extern GVIEW	*GV_Load_PAT4();
extern GVIEW	*GV_Load_Png();

T_Loader	l_table[]= {
	{ ".pi",	GV_Load_Pi	},
	{ ".pic",	GV_Load_Pic	},
	{ ".mag",	GV_Load_Mag	},
	{ ".hg",	GV_Load_Hg	},
	{ ".jpg",	GV_Load_Jpeg	},
	{ ".gif",	GV_Load_Gif	},
	{ ".glm",	GV_Load_Glm	},
	{ ".ppm",	GV_Load_Ppm	},
	{ ".bmp",	GV_Load_Bmp	},
	{ ".pix",	GV_Load_Pix	},
	{ ".pt4",	GV_Load_PAT4	},
	{ ".png",	GV_Load_Png	},
	{ NULL,		NULL		},
};



GVIEW *
GV_LoaderExec( fname )
char	*fname;
{
	unsigned char	*p= fname, *e= NULL;
	for(; *p ; p++ ){
		if( *p == '.' )
			e= p;
	}
	if( e ){
		T_Loader	*tp= l_table;
		for(; tp->ext ; tp++ ){
			if( !strcmpi( tp->ext, e ) )
				return	(*tp->exec)( PathGetFullName(fname) );
		}
	}
	GV_Err2( fname, "gqł܂" );
	return	NULL;
}

